import java.lang.annotation.*; 
/**
 * Declaracion de anotacion propia que sirve para anotar
 * a una clase como clase a ser utilizada en abm usando JTable
 * 
 * @author G.Cherencio
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Inherited  
@interface JTableColumn
{
	boolean pagination() default false;
    String queryLoad() default "";
	int pageSize() default 1;
	String spPageCount() default "";
}
