
/**
 * Interfase utilizada para ejecutar metodo cuando se selecciona
 * fila en JTable
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public interface MiRowListener
{
    /**
     * Metodo que sera llamado por MiTableModel cada vez que se selecciona una fila
     * de la JTable y existan uno o mas objetos MiRowListener registrados
     * 
     * @param index nro de fila seleccionada en JTable
     * @param entity objeto entidad seleccionado en fila de JTable
     * @param mtm objeto table model asociado con JTable
     */
    void selectRow(int index,JEntity entity,MiTableModel mtm);
}
