import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Write a description of class AgendaEspecifica here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AgendaEspecificaCampos extends JFrame
{
    // instance variables - replace the example below with your own
    private String campo;
    private int largo;
    private int registro;
    private final int LARGO = 65; // 1 estado, 60 campo, 4 largo
    private RandomAccessFile raf = null;
    private JTextField txt_registro = new JTextField("");
    private JTextField txt_campo = new JTextField("");
    private JTextField txt_largo = new JTextField("");
    private JButton btn_alta = new JButton("Grabar");
    private JButton btn_baja = new JButton("Borrar");
    private JButton btn_cancel = new JButton("Cancelar");
    /**
     * Constructor for objects of class AgendaEspecifica
     */
    public AgendaEspecificaCampos() {
        // initialise instance variables
        super("Agenda Generica Defina Campos");
        Container cp = getContentPane();
        JPanel pl = new JPanel();
        JPanel plinf = new JPanel();
        
        pl.setLayout(new GridLayout(3,2));
        plinf.setLayout(new GridLayout(1,3));
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing() {
                cerrar();
                System.exit(0);
            }
        });
        txt_registro.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Integer i = null;
                try { 
                    i = new Integer(txt_registro.getText());
                    if ( i.intValue() >= 0 ) {
                        registro = i.intValue();
                        leer();
                        activoCampos(true);
                        txt_campo.requestFocus();
                        txt_registro.setEnabled(false);
                        activoBotones(true);
                    } else {
                        muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                    }
                } catch(NumberFormatException nfe) {
                    muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                }
            }
        });
        btn_alta.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if ( valido() ) { 
                    System.out.println("grabar()");
                    grabar();
                    System.out.println("fin grabar()");
                    txt_registro.setEnabled(true);
                    txt_registro.requestFocus();
                    activoBotones(false);
                    activoCampos(false);
                }
            }
        });
        btn_baja.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 System.out.println("borrar()");
                 borrar();
                 System.out.println("fin borrar()");
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        btn_cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        
        pl.add(new JLabel("Posicion:"));
        pl.add(txt_registro);
        pl.add(new JLabel("Campo:"));
        pl.add(txt_campo);
        pl.add(new JLabel("Largo:"));
        pl.add(txt_largo);
        plinf.add(btn_alta);
        plinf.add(btn_baja);
        plinf.add(btn_cancel);
        cp.add(pl,"Center");
        cp.add(plinf,"South");
        cp.add(new JLabel("Agenda Generica - Defina Campos"),"North");
        setSize(500,150);
        setLocation(new Point(400,300));
        setVisible(true);
        try {
            raf = new RandomAccessFile("estructura.dat","rw");
        } catch(IOException ioe) {}
        activoCampos(false);
        activoBotones(false);
    }
//GETTERS
    
//SETTERS
//CUSTOM
    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public void cerrar() {
        try { raf.close(); } catch(IOException ioe) {}
    }
    public void leer() {
        byte[] bcmp = new byte[60];
        int iedad;
        campo = "";
        largo = 0;
        try {
            raf.seek(registro * LARGO);
            if ( raf.readBoolean() ) { // registro activo
                raf.read(bcmp);
                iedad = raf.readInt();
                campo = new String(bcmp);
                largo = iedad;
            } else { // registro inactivo/borrado
            }
        } catch(IOException ioe) {
        }
        txt_campo.setText(campo);
        txt_largo.setText(""+largo);
    }
    public void grabar() {
        Integer ii = null;
        campo = txt_campo.getText();
        try {
            ii = new Integer(txt_largo.getText());
            largo = ii.intValue();
        } catch(NumberFormatException nfe) {
            largo = 0;
        }
        byte[] bcmp = new byte[60];
        int i;
        byte[] tmp = campo.getBytes();
        System.arraycopy(tmp,0,bcmp,0,tmp.length);
        for(i = tmp.length;i<60;i++) bcmp[i] = ' ';
        try {
            raf.seek(registro * LARGO);
            System.out.println("grabar boolean");
            raf.writeBoolean(true); // registro activo
            System.out.println("grabar byte[] 1");
            raf.write(bcmp);
            System.out.println("grabar int 4");
            raf.writeInt(largo);
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " grabando registro " + registro);
        }
    }
    public void borrar() {
        try {
            raf.seek(registro * LARGO);
            System.out.println("borrar boolean");
            raf.writeBoolean(false); // registro borrado 
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " borrando registro " + registro);
        }
    }
    public static void main(String[] arg) {
        new AgendaEspecificaCampos();
    }
    public void activoCampos(final boolean b) {
        txt_campo.setEnabled(b);
        txt_largo.setEnabled(b);
    }
    public void activoBotones(final boolean b) {
        btn_alta.setEnabled(b);
        btn_baja.setEnabled(b);
        btn_cancel.setEnabled(b);
    }
    public boolean valido() {
        if ( txt_campo.getText().length() == 0 ) return muestroError("Debe Ingresar campo",txt_campo);
        if ( txt_campo.getText().length() > 60 ) return muestroError("El campo no puede superar 60 caracteres",txt_campo);
        if ( txt_largo.getText().length() == 0 ) return muestroError("Debe Ingresar largo",txt_largo);
        Integer i = null;
        try {
            i = new Integer(txt_largo.getText());
            if ( i.intValue() < 0 ) return muestroError("La largo debe ser mayor que 0",txt_largo);
        } catch(NumberFormatException nfe) {
            return muestroError(txt_largo.getText() + " no es un numero entero mayor que 0.",txt_largo);
        }
        return true;
    }
    public boolean muestroError(final String msg,final JComponent comp) {
        JOptionPane.showMessageDialog(null, msg, "Agenga Especifica - Error", JOptionPane.ERROR_MESSAGE); 
        comp.requestFocus();
        return false;
    }
}
