
/**
 * Clase de utileria, con metodos static para realizar conversiones y demas yerbas
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public class Util {
    /**
     * nro es el numero entero a pasar a String
     * largo es la cantidad de digitos String
     * nro sera alineado hacia la derecha
     */
    public static String intToString(int nro,int largo) {
        StringBuffer sb = new StringBuffer();
        // genero <largo> espacios dentro del StringBuffer
        for(int i=0;i<largo;i++) sb.append(" ");
        sb.append(nro);
        String snro = sb.toString(); // "       2133"
        String ssnro = snro.substring(snro.length()-largo,snro.length()); // " 2133"
        return ssnro;
    }
    
    /**
     * snro es un String a convertir en <largo> bytes
     * largo es la cantidad de digitos que deberia contener el String
     */
    public static byte[] stringToByte(String snro,int largo) {
        StringBuffer sb = new StringBuffer();
        sb.append(snro.trim()); // "   pepe   "
        // genero <largo> espacios dentro del StringBuffer
        for(int i=0;i<largo;i++) sb.append(" ");
        String ssnro = sb.toString(); // "pepe          "
        String sssnro = ssnro.substring(0,largo); // "pepe      "
        return sssnro.getBytes();
    }
    
}
