/**
 * Implementacion de una interfase vacia. Esto es totalmente valido y aunque parezca
 * inservible no lo es tan asi, vean por ejemplo el caso de la interfase Serializable
 * que se encuentra en el paquete java.io de la API de Java.
 * Este tipo de interfases sirven a modo de "bandera", para indicar que una determinada
 * clase es de tipo "Serializable" (por el solo hecho de implementar la interfase Serializable,
 * lo cual es simplemente declarar la clase diciendo implements Serializable, ya que esta no
 * requiere de la implementacion de ningun metodo)
 * En runtime podemos comprobar si un determinado objeto (que es una instancia de una determinada
 * clase) es "Serializable" o no "Serializable", la pregunta: if (obj instanceof Serializable) 
 * seria verdad en tal caso.
 * Asi lo demuestra la clase Auto.
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public interface SuperCosa {
}
