
/**
 * Aplicacion de prueba
 *
 * @author G. Cherencio
 * @version 1.0
 */
public class Main {
    public static void main(String[] arg) {
        Avion av = new Avion();
        av.volar();
        System.out.println("av.getNombre()="+av.getNombre());
        Volador v1 = new Avion("Airbus A30");
        v1.volar();
        //System.out.println("v1.getNombre()="+v1.getNombre());  // Error getNombre() no es metodo de Volador!!
        // clase anonima que implementa la interfaz Volador
        Volador v2 = new Volador() {
            public void volar() {
                System.out.println("Implementacion de volar() en clase anonima");
            }
            public void aterrizar() {
                System.out.println("Implementacion de aterrizar() en clase anonima");
            }
        };
        v2.volar();
        AlgoQueVuela aqv = new Avion("767");
        aqv.volar();
        System.out.println("aqv.getNombre()="+aqv.getNombre());
        Pajaro p = new Pajaro("tero");
        p.volar();
        p.aterrizar();
    }
}
