import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.TableModel;
import javax.swing.table.TableCellRenderer;

public class ViewTable {
    private JFrame fr;
    private JPanel p1;
    private JPanel p2;
    private JTable t1;
    private JTable t2;
    private MiTableModel mtm2;
    private MiTableModel mtm;
    private JButton btn_close = new JButton();
    //private JButton btn_next = new JButton();
    //private JButton btn_prev = new JButton();
    //private MiCombo mc = new MiCombo("SELECT DESCR,CODIGO FROM CLIENTE ORDER BY DESCR ASC",1,false);
    //private JButton btn_test = new JButton("Test Combo!");
                    
    public ViewTable() {
        fr = new JFrame("Clientes");
        p1 = new JPanel();
        p2 = new JPanel();
        t1 = new JTable();
        t2 = new JTable();
        FlowLayout fl = new FlowLayout();
        fl.setAlignment(1);
        fl.setHgap(30);
                
        fr.setLayout(new BorderLayout());
        p1.setLayout(new GridLayout(1,2));
        p2.setLayout(fl);
        mtm = new MiTableModel(t1,"Cliente");
        mtm2 = new MiTableModel(t2,"Factura");

        mtm.addRowListener(new MiRowListener() {
            public void selectRow(int index,JEntity entity,MiTableModel mtm) {
                if ( entity != null ) mtm2.setQueryLoad("SELECT * FROM FACTURA WHERE CODIGO = "+((Cliente) entity).getCodigo()+" ORDER BY NRO");
                else                  mtm2.setQueryLoad("SELECT * FROM FACTURA WHERE 1 = 2 ORDER BY NRO");
                mtm2.doRefresh();
            }
        });
        mtm.doRowSelection(0);
        
        p1.add(mtm.getScrollPane());
        p1.add(mtm2.getScrollPane());
        fr.add(p1,"Center");
        //p2.add(btn_prev);                
        p2.add(btn_close);
        //p2.add(btn_next);        
        //p2.add(mc);
        ///p2.add(btn_test);
        fr.add(p2,"South");

        //btn_prev.setIcon(new ImageIcon("previous.png","Salir"));
        btn_close.setIcon(new ImageIcon("close.png","Salir"));
        //btn_next.setIcon(new ImageIcon("next.png","Salir"));                
        btn_close.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int confirmado = JOptionPane.showConfirmDialog(null,
                    "¿Estas seguro?","Cerrar",JOptionPane.YES_NO_OPTION);
                if (JOptionPane.OK_OPTION == confirmado) fr.dispose();  // cierra el JFrame fr
            }
        });
        
        /**btn_test.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("------------------");
                System.out.println(mc);
                System.out.println("getSelectedItem(): "+mc.getSelectedItem());
                System.out.println("getSelectedIndex(): "+mc.getSelectedIndex());
                System.out.println("getValue(): "+mc.getValue());
                System.out.println("------------------");
            }
        });*/
        
        fr.addWindowListener(new WindowAdapter() {
            public void windowClosed(WindowEvent e) {
                DataIO.finish();
            }
            public void windowClosing(WindowEvent e) {
                DataIO.finish();
            }
        });
        
    
        fr.setSize(710,510);
        fr.setVisible(true);
        fr.setLocationRelativeTo(null); //posiciona Jframe en el medio de la pantalla
    }
   
    public static void main(String[] args) {
        DataIO.setDatabase("localhost:/var/lib/firebird/2.5/data/cli.fdb");
        DataIO.setUser("sysdba");
        DataIO.setRole("sysdb");
        DataIO.setPassword("masterkey");
        // envio el pedido de conexion a la b.d.
        if ( DataIO.init() ) {
            // me conecte!
            System.out.println("Me Conecte!");
        } else {
            // maldicion! no me conecte!
            System.out.println(DataIO.getErrorMessages());
        }
        new ViewTable();
    }
    
    
}

