import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Write a description of class AgendaEspecifica here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AgendaEspecifica extends JFrame
{
    // instance variables - replace the example below with your own
    private String apellido;
    private String nombres;
    private String direccion;
    private int edad;
    private int registro;
    private final int largo = 95; // 1 estado, 30 apellido, 30 nombres, 30 direccion, 4 edad
    private RandomAccessFile raf = null;
    private JTextField txt_registro = new JTextField("");
    private JTextField txt_apellido = new JTextField("");
    private JTextField txt_nombres = new JTextField("");
    private JTextField txt_direccion = new JTextField("");
    private JTextField txt_edad = new JTextField("");
    private JButton btn_alta = new JButton("Grabar");
    private JButton btn_baja = new JButton("Borrar");
    private JButton btn_cancel = new JButton("Cancelar");
    /**
     * Constructor for objects of class AgendaEspecifica
     */
    public AgendaEspecifica() {
        // initialise instance variables
        super("Agenda Especifica");
        Container cp = getContentPane();
        JPanel pl = new JPanel();
        JPanel plinf = new JPanel();
        
        pl.setLayout(new GridLayout(5,2));
        plinf.setLayout(new GridLayout(1,3));
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing() {
                cerrar();
                System.exit(0);
            }
        });
        txt_registro.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Integer i = null;
                try { 
                    i = new Integer(txt_registro.getText());
                    if ( i.intValue() >= 0 ) {
                        registro = i.intValue();
                        leer();
                        activoCampos(true);
                        txt_apellido.requestFocus();
                        txt_registro.setEnabled(false);
                        activoBotones(true);
                    } else {
                        muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                    }
                } catch(NumberFormatException nfe) {
                    muestroError(txt_registro.getText() + " no es un numero entero entre 0 y n",txt_registro);
                }
            }
        });
        btn_alta.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if ( valido() ) { 
                    System.out.println("grabar()");
                    grabar();
                    System.out.println("fin grabar()");
                    txt_registro.setEnabled(true);
                    txt_registro.requestFocus();
                    activoBotones(false);
                    activoCampos(false);
                }
            }
        });
        btn_baja.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 System.out.println("borrar()");
                 borrar();
                 System.out.println("fin borrar()");
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        btn_cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                 txt_registro.setEnabled(true);
                 txt_registro.requestFocus();
                 activoBotones(false);
                 activoCampos(false);
            }
        });
        
        pl.add(new JLabel("Posicion:"));
        pl.add(txt_registro);
        pl.add(new JLabel("Apellido:"));
        pl.add(txt_apellido);
        pl.add(new JLabel("Nombres:"));
        pl.add(txt_nombres);
        pl.add(new JLabel("Direccion:"));
        pl.add(txt_direccion);
        pl.add(new JLabel("Edad:"));
        pl.add(txt_edad);
        plinf.add(btn_alta);
        plinf.add(btn_baja);
        plinf.add(btn_cancel);
        cp.add(pl,"Center");
        cp.add(plinf,"South");
        cp.add(new JLabel("Agenda Especifica"),"North");
        setSize(400,200);
        setLocation(new Point(400,300));
        setVisible(true);
        try {
            raf = new RandomAccessFile("agendae.dat","rw");
        } catch(IOException ioe) {}
        activoCampos(false);
        activoBotones(false);
    }
//GETTERS
    
//SETTERS
//CUSTOM
    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    public void cerrar() {
        try { raf.close(); } catch(IOException ioe) {}
    }
    public void leer() {
        byte[] bape = new byte[30];
        byte[] bnom = new byte[30];
        byte[] bdir = new byte[30];
        int iedad;
        apellido = "";
        nombres = "";
        direccion = "";
        edad = 0;
        try {
            raf.seek(registro * largo);
            if ( raf.readBoolean() ) { // registro activo
                raf.read(bape);
                raf.read(bnom);
                raf.read(bdir);
                iedad = raf.readInt();
                apellido = new String(bape);
                nombres = new String(bnom);
                direccion = new String(bdir);
                edad = iedad;
            } else { // registro inactivo/borrado
            }
        } catch(IOException ioe) {
        }
        txt_apellido.setText(apellido);
        txt_nombres.setText(nombres);
        txt_direccion.setText(direccion);
        txt_edad.setText(""+edad);
    }
    public void grabar() {
        Integer ii = null;
        apellido = txt_apellido.getText();
        nombres = txt_nombres.getText();
        direccion = txt_direccion.getText();
        try {
            ii = new Integer(txt_edad.getText());
            edad = ii.intValue();
        } catch(NumberFormatException nfe) {
            edad = 0;
        }
        byte[] bape = new byte[30];
        byte[] bnom = new byte[30];
        byte[] bdir = new byte[30];
        int iedad,i;
        byte[] tmp = apellido.getBytes();
        System.arraycopy(tmp,0,bape,0,tmp.length);
        for(i = tmp.length;i<30;i++) bape[i] = ' ';
        tmp = nombres.getBytes();
        System.arraycopy(tmp,0,bnom,0,tmp.length);
        for(i = tmp.length;i<30;i++) bnom[i] = ' ';
        tmp = direccion.getBytes();
        System.arraycopy(tmp,0,bdir,0,tmp.length);
        for(i = tmp.length;i<30;i++) bdir[i] = ' ';
        try {
            raf.seek(registro * largo);
            System.out.println("grabar boolean");
            raf.writeBoolean(true); // registro activo
            System.out.println("grabar byte[] 1");
            raf.write(bape);
            System.out.println("grabar byte[] 2");
            raf.write(bnom);
            System.out.println("grabar byte[] 3");
            raf.write(bdir);
            System.out.println("grabar int 4");
            raf.writeInt(edad);
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " grabando registro " + registro);
        }
    }
    public void borrar() {
        try {
            raf.seek(registro * largo);
            System.out.println("borrar boolean");
            raf.writeBoolean(false); // registro borrado 
        } catch(IOException ioe) {
            System.out.println("Error " + ioe + " borrando registro " + registro);
        }
    }
    public static void main(String[] arg) {
        new AgendaEspecifica();
    }
    public void activoCampos(final boolean b) {
        txt_apellido.setEnabled(b);
        txt_nombres.setEnabled(b);
        txt_direccion.setEnabled(b);
        txt_edad.setEnabled(b);
    }
    public void activoBotones(final boolean b) {
        btn_alta.setEnabled(b);
        btn_baja.setEnabled(b);
        btn_cancel.setEnabled(b);
    }
    public boolean valido() {
        if ( txt_apellido.getText().length() == 0 ) return muestroError("Debe Ingresar Apellido",txt_apellido);
        if ( txt_apellido.getText().length() > 30 ) return muestroError("El Apellido no puede superar 30 caracteres",txt_apellido);
        if ( txt_nombres.getText().length() == 0 ) return muestroError("Debe Ingresar Nombres",txt_nombres);
        if ( txt_nombres.getText().length() > 30 ) return muestroError("Los Nombres no pueden superar 30 caracteres",txt_nombres);
        if ( txt_direccion.getText().length() == 0 ) return muestroError("Debe Ingresar Direccion",txt_direccion);
        if ( txt_direccion.getText().length() > 30 ) return muestroError("La Direccion no puede superar 30 caracteres",txt_direccion);
        if ( txt_edad.getText().length() == 0 ) return muestroError("Debe Ingresar Edad",txt_edad);
        Integer i = null;
        try {
            i = new Integer(txt_edad.getText());
            if ( i.intValue() < 0 || i.intValue() > 100 ) return muestroError("La Edad debe estar entre 0 y 100",txt_edad);
        } catch(NumberFormatException nfe) {
            return muestroError(txt_edad.getText() + " no es un numero entero.",txt_edad);
        }
        return true;
    }
    public boolean muestroError(final String msg,final JComponent comp) {
        JOptionPane.showMessageDialog(null, msg, "Agenga Especifica - Error", JOptionPane.ERROR_MESSAGE); 
        comp.requestFocus();
        return false;
    }
}
