
/**
 * Clase propia de exception para indicar error de rango
 * 
 * @author G.Cherencio
 * @version 1.0
 */
public class RangeException extends Exception {
    public RangeException() {
        super();
    }
    public RangeException(String msgErr) {
        super(msgErr);
    }
    public RangeException(int value,int desde,int hasta) {
        super("Error! "+value+" no esta entre "+desde+" y "+hasta);
    }
}
