import java.util.Date;
import java.text.SimpleDateFormat;
import java.text.ParseException;
/**
 * Uso basico de import y manejo de fechas
 * 
 * @author G.Cherencio 
 * @version 1.0
 */
public class App {
    public static void main(String arg[]) {
        // fecha-hora actual
        Date d = new Date();
        // formateando la fecha-hora actual con formato dd-MM-yyyy y pasandola a String
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
        // el metodo format, devuelve un String con la fecha formateada
        String sd = sdf.format(d);
        System.out.println(sd);
       
        String fecha = "25-05-2016";
        try {
            Date dfecha = sdf.parse(fecha);
            System.out.println(fecha+" se formateo Ok");
        } catch (ParseException ex) {
            System.err.println(fecha+" no puede ser formateada");
        }
    }        
}
