import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * Manipulador generico de eventos Action de AppGUI
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class AccionesGUI2 implements ActionListener {
    private AppGUI2 app = null;
    private JTextField tleg = null;
    private JTextField tape = null;
    private JTextField tnom = null;
    private FObjectPk f = null;

    public AccionesGUI2() {
        f = new FObjectPk();
    }
    public AccionesGUI2(FObjectPk f,AppGUI2 app) {
        this.f=f;
        this.app = app;
        tleg = (JTextField) app.getComponent("tleg");
        tape = (JTextField) app.getComponent("tape");
        tnom = (JTextField) app.getComponent("tnom");
    }
    @Override
    public void actionPerformed(ActionEvent e) {
        // cual boton fue presionado?
        // como accedo a atributos o componentes dentro de AppGUI??
        if ( app == null ) {
            System.err.println("No puedo manejar eventos, app no indicada!");
            return;
        }
        Object fuente = e.getSource(); // fuente del evento
        if ( fuente instanceof JButton ) {
            // presiono un boton, pero cual??
            String accion = ((JButton) fuente).getActionCommand();
            if ( accion.equals("grabar") ) {
                try {
/*                    
        fo.getFAlumno().setEstado((byte) 1);
        fo.getFAlumno().setLegajo(1234);
        fo.getFAlumno().setApellido("Rodriguez");
        fo.getFAlumno().setNombre("Carlos");
        fo.grabar(1234);
*/                    
                    Integer legajo = new Integer(tleg.getText());
                    f.getFAlumno().setLegajo(legajo);
                    f.getFAlumno().setApellido(tape.getText());
                    f.getFAlumno().setNombre(tnom.getText());
                    f.getFAlumno().setEstado((byte) 1);
                    f.grabar(legajo);
                    habilito(false);
                } catch(NumberFormatException nfe) {
                }
            } else if ( accion.equals("borrar") ) {
                Integer legajo = new Integer(tleg.getText());
                if ( f.leer(legajo) ) {
                    f.getFAlumno().setEstado((byte) 2);
                    f.grabar(legajo);
                    habilito(false);
                }
            } else if ( accion.equals("listar") ) {
                StringBuffer sb = new StringBuffer();
                sb.append("<html><body><table border=1>");
                sb.append("<tr><td colspan=4><center>Listado de Alumnos</center></td></tr>");
                sb.append("<tr><td>Registro</td><td>Legajo</td><td>Apellido</td><td>Nombre</td></tr>");
                Set<Integer> si = f.getMap().keySet();
                Iterator<Integer> ii = si.iterator();
                while(ii.hasNext()) {
                    Integer leg = ii.next();
                    if (f.leer(leg)) {
                        sb.append("<tr><td>"+f.getMap().get(leg)+"</td><td>"+f.getFAlumno().getLegajo()+"</td><td>"+f.getFAlumno().getApellido()+"</td><td>"+f.getFAlumno().getNombre()+"</td></tr>");
                    }
                }
                sb.append("</table></body></html>");
                new ViewTxt(sb.toString());
            } else { // no se quien es!
            }
        } else if ( fuente instanceof JTextField ) {
            String sleg = ((JTextField) app.getComponent("tleg")).getText();
            try {
                Integer ileg = new Integer(sleg);
                if ( f.leer(ileg) ) {
                    tape.setText(f.getFAlumno().getApellido().trim());
                    tnom.setText(f.getFAlumno().getNombre().trim());
                } else {
                    tape.setText("");
                    tnom.setText("");
                }
                habilito(true);
            } catch(NumberFormatException nfe) {
                System.err.println("["+sleg+"] no es un numero entero valido!");
            }

        }
        
    }
    /**
     * habilita/deshabilita los componentes de texto de la pantalla
     */
    public void habilito(boolean b) {
        //tleg.setEnabled(b);
        tape.setEnabled(b);
        tnom.setEnabled(b);
    }
}
