import javax.swing.*;

/**
 * eng:GUI for show html code into swing window. It has used to show rich help messages 
 * to user.
 * <br>
 * spa:GUI para mostrar codigo html en una ventana swing. Ha sido usada para mostrar
 * mensajes al usuario.
 * 
 * @author G.Cherencio 
 * @version 1.0
 * @since 1.7
 */
public class ViewTxt extends JFrame {
    public ViewTxt() {
        super();
    }
    public ViewTxt(String cont) {
        this(cont,600,600);
    }
    public ViewTxt(String cont,int ww,int hh) {
        super();
        //JTextArea jtxt = new JTextArea(cont);
        JTextPane jtxt = new JTextPane();
        jtxt.setContentType("text/html");
        jtxt.setEditable(false);
        jtxt.setText(cont);
        JScrollPane js = new JScrollPane(jtxt);
        jtxt.setEditable(false);
        getContentPane().add(js);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setSize(ww, hh);
        setLocationRelativeTo(null);
        setVisible(true);
    }
    
}
