import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Write a description of class View here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class View {
    // paso 1
    private JFrame fr;
    private JPanel p1;
    private JList<Integer> lst_reg;
    private JPanel p2;
    private JPanel p3;
    private JLabel lbl_codigo;
    private JTextField txt_codigo;
    private JLabel lbl_descr;
    private JTextField txt_descr;
    private JLabel lbl_saldo;
    private JTextField txt_saldo;
    private JPanel p4;
    private JButton btn_nuevo;
    private JButton btn_borrar;
    private JButton btn_grabar;

    private Model m = new Model();
    private Controller c = new Controller();
    
    public View() {
        //paso 3
        fr = new JFrame("ABM CLIENTES");
        p1 = new JPanel();
        p2 = new JPanel();
        p3 = new JPanel();
        p4 = new JPanel();
        lst_reg = new JList<Integer>();
        lbl_codigo = new JLabel("Codigo: ");
        lbl_descr = new JLabel("Descripcion: ");
        lbl_saldo = new JLabel("Saldo: ");
        txt_codigo = new JTextField("");
        txt_descr = new JTextField("");
        txt_saldo = new JTextField("");
        btn_nuevo = new JButton("Nuevo");
        btn_borrar = new JButton("Borrar");
        btn_grabar = new JButton("Grabar");        
        // paso 4
        fr.setLayout(new BorderLayout());
        p1.setLayout(new GridLayout(1,2));
        p2.setLayout(new BorderLayout());
        p3.setLayout(new GridLayout(3,2));
        p4.setLayout(new GridLayout(1,3));
        // paso 5
        fr.add(p1,"Center");
        p1.add(lst_reg);
        
        //lst_reg.
        p1.add(p2);
        p2.add(p3,"Center");
        p2.add(p4,"South");
        p3.add(lbl_codigo);
        p3.add(txt_codigo);
        p3.add(lbl_descr);
        p3.add(txt_descr);
        p3.add(lbl_saldo);
        p3.add(txt_saldo);
        p4.add(btn_nuevo);
        p4.add(btn_borrar);
        p4.add(btn_grabar);
        // paso 6, agregamos manipulador de eventos (controller)
        // configuro controlador
        c.setModel(m);
        c.setView(this);
        btn_nuevo.setActionCommand("nuevo");
        btn_borrar.setActionCommand("borrar");
        btn_grabar.setActionCommand("grabar");
        
        btn_nuevo.addActionListener(c);
        btn_borrar.addActionListener(c);
        btn_grabar.addActionListener(c);
        
        // cargo contenido del archivo en memoria  (usando TreeMap<Integer,Cliente>)
        c.getModel().load();
        
        // asocio txts a controller
        c.setTxt(0,txt_codigo);
        c.setTxt(1,txt_descr);
        c.setTxt(2,txt_saldo);
        c.setList(lst_reg);
        
        // creo model, basado en map<Integer,Cliente> para JList
         ListModel<Integer> lm = new AbstractListModel<Integer>() {
             public int getSize() { return c.getModel().getMap().size(); }
             public Integer getElementAt(int index) {
                 if ( c.getModel().getMap().containsKey(index) ) return index;
                 return null;
             }
         };        
         lst_reg.setModel(lm);
         lst_reg.addListSelectionListener(c);
        
        // paso 7
        fr.setSize(550,150);
        fr.setVisible(true);
        
    }

    public static void main(String[] args) {
        new View();
    }
}
