import java.io.*;
/**
 * Este proyecto no compila!
 * No se preocupe si no entiende por completo el concepto de excepcion si aun no ha visto
 * el capitulo 12.
 * Porque estamos violando una de las reglas de la sobreescritura (overriding) en cuanto
 * al manejo de excepciones.
 * El metodo leoCaracter() de la clase Padre lanza la excepcion java.io.IOException, si bien
 * puede lanzar esta excepcion (debido a que utiliza el metodo read() de la clase InputStream,
 * ya que, System.in es de tipo InputStream) el metodo declara que puede lanzar la excepcion
 * java.lang.Exception (que es mas generica que java.io.IOException, puesto que java.lang.Exception
 * es superclase de java.io.IOException).
 * Luego en la clase Hijo se sobreescribe el metodo leoCaracter() diciendo que puede lanzar la 
 * excepcion java.io.IOException lo cual no viola ninguna regla de la sobreescritura por el hecho
 * de que java.io.IOException es una subclase de java.lang.Exception.
 * La clase Nieto pretende sobreescribir el metodo leoCaracter() diciendo que puede lanzar la 
 * excepcion java.lang.Exception lo cual si es violatorio de una de las reglas de la sobreescritura
 * por el hecho de que java.lang.Exception no es una subclase de java.io.IOException, mas bien,
 * todo lo contrario, java.io.IOException es subclase de java.lang.Exception.
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Padre
{
	// instance variables - replace the example below with your own

	/**
	 * Constructor for objects of class PadreHijo
	 */
	public Padre()
	{
		// initialise instance variables
	}

	/**
	 * An example of a method - replace this comment with your own
	 * 
	 * @param  y   a sample parameter for a method
	 * @return     the sum of x and y 
	 */
	public void leoCaracter() throws Exception // java.lang.Exception es superclase de java.io.IOException
	{
		// put your code here
		char c = (char) System.in.read();
	}
}

class Hijo extends Padre {
	public void leoCaracter() throws IOException  // java.io.IOException es subclase de java.lang.Exception
	{
		// put your code here
		char c = (char) System.in.read();
	}
}

class Nieto extends Hijo {
    // la siguiente linea no compila!
	public void leoCaracter() throws Exception  // java.lang.Exception no es subclase de java.io.IOException
	{
		// put your code here
		char c = (char) System.in.read();
	}
}